// Osf2xView.cpp : COsf2xView NX̓̒`s܂B
// by Toshio Iwata at digitalfilter.com 2004/09/16

#include "stdafx.h"
#include "Osf2x.h"

#include "Osf2xDoc.h"
#include "Osf2xView.h"
#include "DlgRng.h"
#include "DlgWrErr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COsf2xView

IMPLEMENT_DYNCREATE(COsf2xView, CView)

BEGIN_MESSAGE_MAP(COsf2xView, CView)
	//{{AFX_MSG_MAP(COsf2xView)
	ON_COMMAND(ID_MENU_WVLD, OnMenuWvld)
	ON_COMMAND(ID_MENU_WVSV, OnMenuWvsv)
	ON_COMMAND(ID_MENU_RNG, OnMenuRng)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COsf2xView NX̍\z/

COsf2xView::COsf2xView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	int i;
	TapN = 100;
	Pi = 3.14159;
	Fsamp = 22050;
	gain_range = 100.0;
	gain_offset = 0.0;
	freq_range = Fsamp/2;
	wave_loaded = FALSE;
	wave_calculated = FALSE;
	for( i = 0; i < 100; i++ ) hh[i] = 0.0;
	mono1_stereo2 = 1;
	samplingfreq = 22050;
	bitlength = 8;
	totalbytes = 22050;
	bytesinfile = 22050;
	chbytes_per_sample = 1;
	bytes_per_sample = 1;
	bytes_per_sec = 22050;
	wavesize = 22050;
	timelength = 1;
	allocated = FALSE;
	yframe = 100;
	yrng = 10000;
	xstart = 0;
	allocated2 = FALSE;
	allocated3 = FALSE;
}

COsf2xView::~COsf2xView()
{
}

BOOL COsf2xView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COsf2xView NX̕`

void COsf2xView::OnDraw(CDC* pDC)
{
	COsf2xDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	if(wave_loaded) {
		if(!wave_calculated) InitCoeffs();
		pDC->TextOut(100, 20, "Input Wave");
		WaveDraw(pDC, 80, 80, InWave, FALSE);
		if(!wave_calculated) Interpolate();
		pDC->TextOut(100, 150, "Interpolated Wave");
		WaveDraw(pDC, 80, 210, IpWave, TRUE);
		if(!wave_calculated) FirOutWaveCal();
		pDC->TextOut(100, 280, "Output Wave");
		WaveDraw(pDC, 80, 340, OutWave, TRUE);
	} else {
		pDC->TextOut( 50, 50, "Osf2x.exe");
		pDC->TextOut( 50, 80, "Q{I[oTvOtB^B");
		pDC->TextOut( 50, 110, "TvOg2205044100ɕϊ܂B");
		pDC->TextOut( 50, 140, "uWavet@CvuWaveǂݍ݁vIĂB");
		pDC->TextOut( 50, 170, "by DIGITALFILTER.COM");
	}
}

/////////////////////////////////////////////////////////////////////////////
// COsf2xView NẌ

BOOL COsf2xView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void COsf2xView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void COsf2xView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// COsf2xView NX̐ff

#ifdef _DEBUG
void COsf2xView::AssertValid() const
{
	CView::AssertValid();
}

void COsf2xView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

COsf2xDoc* COsf2xView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COsf2xDoc)));
	return (COsf2xDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COsf2xView NX̃bZ[W nh

void COsf2xView::OnMenuWvld() 
{
	GetWavInfo();
	InvalidateRect(NULL, TRUE);	
}

void COsf2xView::GetWavInfo()
{
	unsigned long len;
	unsigned char s[10];
	int i;
	long fmtbytes;
	FILE *ifp;
	CString filenameld;
	CFileDialog dlgF(TRUE, "NULL", "*.wav");

	if( dlgF.DoModal() == IDOK)	{
		filenameld = dlgF.GetPathName();
		ifp = fopen( filenameld, "rb" );
		if (ifp != NULL) {
			fread(s, 4, 1, ifp); // "RIFF" 
			bytesinfile = get_ulong(ifp); // total bytes in the file
			fread(s, 8, 1, ifp); // "WAVEfmt" 
			fmtbytes = get_ulong(ifp); // header size
			len = get_ushort(ifp); // 1: pcm
			mono1_stereo2 = get_ushort(ifp); // 1: mono, 2; stereo
			samplingfreq = get_ulong(ifp); // sampling frequency
			Fsamp = (double)samplingfreq;
			freq_range = Fsamp/2;
			bytes_per_sec = get_ulong(ifp); // bytes per second
			chbytes_per_sample = get_ushort(ifp); // channels * bytes per sample
			bitlength = get_ushort(ifp); // bit length
			if( bitlength == 16 ) yrng = 10000; else yrng = 100;
			xstart = 0;
			for (i = 0; i < (fmtbytes-16)/2; i++ ) {
				len = get_ushort(ifp); // skip redundant header information
			}
			do{ // look for "data" chunk
				fread(s, 4, 1, ifp); // expect "data"
				if(((s[0] == 'd')&(s[1] == 'a')&(s[2] == 't')&(s[3] == 'a')) == 0){ // step over chunks unless it's "data" chunk
					len = get_ulong(ifp);
					fseek(ifp, len, SEEK_CUR);
				}else{
					break ;
				}
			} while(1);
			totalbytes = get_ulong(ifp); // total bytes of wav data
			bytes_per_sample = bitlength / 8;
			wavesize = totalbytes / (mono1_stereo2 * bytes_per_sample);
			timelength = (double)wavesize/Fsamp;
			int i, m;
			short x;
			AllocateMemory();
			if (mono1_stereo2 == 1) {
				for (i = 0; i < wavesize; i++) { // read mono wav data
					if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
					if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
					else x = (short)(s[0]) - 128;
					InWave[i] = (double)(x);
				}
			} else {
				for (i = 0; i < wavesize * 2; i++) { // read stereo wav data
					m = i / 2;
					if (fread(s, bytes_per_sample, 1, ifp) != 1) break;
					if (bytes_per_sample == 2) x = (short)(s[0] + 256 * s[1]);
					else x = (short)(s[0]) - 128;
					if(i%2==0) InWave[m] = (double)(x);
					else InWaveR[m] = (double)(x);
				}
			}
			fclose( ifp );
			wave_loaded = TRUE;
			wave_calculated = FALSE;
		}
	}
}

void COsf2xView::AllocateMemory()
{
	if( allocated ) {
		free(InWave);
		free(InWaveR);
	}
	InWave = (double *)calloc(wavesize * 2, sizeof(double));
	InWaveR = (double *)calloc(wavesize * 2, sizeof(double));
	allocated = TRUE;
}

void COsf2xView::AllocateMemory2()
{
	if( allocated2 ) {
		free(OutWave);
		free(OutWaveR);
	}
	OutWave = (double *)calloc(wavesize * 2 + 1000, sizeof(double));
	OutWaveR = (double *)calloc(wavesize * 2 + 1000, sizeof(double));
	allocated2 = TRUE;
}

void COsf2xView::AllocateMemory3()
{
	if( allocated3 ) {
		free(IpWave);
		free(IpWaveR);
	}
	IpWave = (double *)calloc(wavesize * 2 + 1000, sizeof(double));
	IpWaveR = (double *)calloc(wavesize * 2 + 1000, sizeof(double));
	allocated3 = TRUE;
}

unsigned long COsf2xView::get_ulong(FILE *f)
{
    unsigned char s[4];
	unsigned res;

    if (fread(s, 4, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256LU * (s[1] + 256LU * (s[2] + 256LU * s[3]));
	}
    return res;
}

unsigned COsf2xView::get_ushort(FILE *f)
{
    unsigned char s[2];
	unsigned res;

    if (fread(s, 2, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0] + 256U * s[1];
	}
    return res;
}

unsigned COsf2xView::get_ubyte(FILE *f)
{
    unsigned char s[1];
	unsigned res;

    if (fread(s, 1, 1, f) != 1) {
		res = 0;
    } else {
		res = s[0];
	}
    return res;
}

void COsf2xView::FirOutWaveCal() {
	int i, m;
	double acc, accr;
	double tmpL, tmpR;

	AllocateMemory2();
	for( i = 0; i < wavesize * 2; i++ ) {
		OutWave[i] = 0.0; OutWaveR[i] = 0.0;
	}

	double k2 = 1.0;
	for ( i = 0; i < bitlength - 1; i++ ) { 
		k2 = k2 * 2.0;
	}
	k2 = k2 - 1.0;  // k2 = 128 at 8 bits, 32768 for 16 bits
	for(i = 0; i < wavesize * 2; i++) {
		acc = 0.0; 
		accr = 0.0;
		for(m = 0; m < TapN; m++) {
			if(i-m < 0) {
				tmpL = 0.0; tmpR = 0.0;
			} else {
				tmpL = IpWave[i-m];
				tmpR = IpWaveR[i-m];
			}
			acc = acc + 2.0 * hh[m] * tmpL; // 2{I[oTvOȂ̂ŌW2{
			accr = accr + 2.0 * hh[m] * tmpR;
		}
		if(acc > k2) acc = k2; if(accr > k2) accr = k2;
		if(acc < -k2) acc = -k2; if(accr < -k2) accr = -k2;
		OutWave[i] = acc; OutWaveR[i] = accr;
	}
	wave_calculated = TRUE;
}

void COsf2xView::WaveDraw(CDC *pDC, int x1, int y1, double *InW, BOOL oversampled)
{
	CPen	myPen;
	CPen*	pOldPen;

	int i;
	int ytmp;
	char tmpchar[12];
	int xscale = 500;
	int yscale = 40;
	int xstep = 8;

	sprintf(tmpchar,"%7d", yrng);
	pDC->TextOut( x1 - 55, y1 - yscale - 8, tmpchar);
	sprintf(tmpchar,"%6d", -yrng);
	pDC->TextOut( x1 - 55, y1 + yscale - 8, tmpchar);
	pDC->TextOut( x1 - 20, y1 - 8, "0");

	sprintf(tmpchar,"%7.4f", xscale/xstep/Fsamp/2.0);
	pDC->TextOut( x1 + xscale/2 - 30, y1 + yscale + 8, tmpchar);
	sprintf(tmpchar,"%7.4f", xscale/xstep/Fsamp);
	pDC->TextOut( x1 + xscale - 30, y1 + yscale + 8, tmpchar);

	myPen.CreatePen(PS_DOT, 1, RGB(0,255,0));
	pOldPen = pDC->SelectObject(&myPen);

	pDC->MoveTo(x1, y1);
	pDC->LineTo(x1 + xscale, y1);

	pDC->MoveTo(x1, y1 - yscale);
	pDC->LineTo(x1 + xscale, y1 - yscale);

	pDC->MoveTo(x1, y1 + yscale);
	pDC->LineTo(x1 + xscale, y1 + yscale);

	pDC->MoveTo(x1, y1 - yscale);
	pDC->LineTo(x1, y1 + yscale);
	pDC->MoveTo(x1 + xscale * 1 / 4, y1 - yscale);
	pDC->LineTo(x1 + xscale * 1 / 4, y1 + yscale);
	pDC->MoveTo(x1 + xscale * 2 / 4, y1 - yscale);
	pDC->LineTo(x1 + xscale * 2 / 4, y1 + yscale);
	pDC->MoveTo(x1 + xscale * 3 / 4, y1 - yscale);
	pDC->LineTo(x1 + xscale * 3 / 4, y1 + yscale);
	pDC->MoveTo(x1 + xscale, y1 - yscale);
	pDC->LineTo(x1 + xscale, y1 + yscale);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	myPen.CreatePen(PS_SOLID, 1, RGB(0,255,0));
	pOldPen = pDC->SelectObject(&myPen);

	int startint;
	if(!oversampled) {
		startint = (int)(xstart/100.0 * wavesize);
		xstep = 8;
	} else {
		startint = (int)(xstart/100.0 * wavesize * 2);
		xstep = 4;
	}

	for(i = 0; i < 200; i++) {
		if((i+1) * xstep < xscale ) {
			ytmp = (int)(-yscale * InW[startint+i+0] / yrng);
			if( ytmp > yscale ) ytmp = yscale;
			if( ytmp < -yscale ) ytmp = -yscale;
			pDC->MoveTo(x1 + (i+0) * xstep, y1 + ytmp);
			ytmp = (int)(-yscale * InW[startint+i+1] / yrng);
			if( ytmp > yscale ) ytmp = yscale;
			if( ytmp < -yscale ) ytmp = -yscale;
			pDC->LineTo(x1 + (i+1) * xstep, y1 + ytmp);
			pDC->FillSolidRect(x1 + (i+1) * xstep - 1, y1 + ytmp - 1, 3, 3, RGB( 0,0,255 ));
		}
	}
	pDC->SetBkColor(RGB( 255, 255, 255 ));
	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();
}


void COsf2xView::InitCoeffs() { // I[oTvOpFIR^LPF̌W
  hh[0] =   -0.000001475 ;
  hh[1] =   -0.000003967 ;
  hh[2] =    0.000005855 ;
  hh[3] =    0.000013693 ;
  hh[4] =   -0.000013699 ;
  hh[5] =   -0.000034629 ;
  hh[6] =    0.000025226 ;
  hh[7] =    0.000074188 ;
  hh[8] =   -0.000039310 ;
  hh[9] =   -0.000142494 ;
  hh[10] =    0.000052293 ;
  hh[11] =    0.000252195 ;
  hh[12] =   -0.000057142 ;
  hh[13] =   -0.000418689 ;
  hh[14] =    0.000041510 ;
  hh[15] =    0.000658752 ;
  hh[16] =    0.000012722 ;
  hh[17] =   -0.000990683 ;
  hh[18] =   -0.000132227 ;
  hh[19] =    0.001431150 ;
  hh[20] =    0.000351416 ;
  hh[21] =   -0.001995909 ;
  hh[22] =   -0.000716451 ;
  hh[23] =    0.002694497 ;
  hh[24] =    0.001282415 ;
  hh[25] =   -0.003532792 ;
  hh[26] =   -0.002119814 ;
  hh[27] =    0.004505447 ;
  hh[28] =    0.003310219 ;
  hh[29] =   -0.005601968 ;
  hh[30] =   -0.004958832 ;
  hh[31] =    0.006796937 ;
  hh[32] =    0.007193218 ;
  hh[33] =   -0.008061168 ;
  hh[34] =   -0.010193260 ;
  hh[35] =    0.009349699 ;
  hh[36] =    0.014214474 ;
  hh[37] =   -0.010618851 ;
  hh[38] =   -0.019685879 ;
  hh[39] =    0.011811702 ;
  hh[40] =    0.027386143 ;
  hh[41] =   -0.012880694 ;
  hh[42] =   -0.038995279 ;
  hh[43] =    0.013770045 ;
  hh[44] =    0.058881968 ;
  hh[45] =   -0.014442342 ;
  hh[46] =   -0.103173939 ;
  hh[47] =    0.014857393 ;
  hh[48] =    0.317321894 ;
  hh[49] =    0.485000000 ;
  hh[50] =    0.317321894 ;
  hh[51] =    0.014857393 ;
  hh[52] =   -0.103173939 ;
  hh[53] =   -0.014442342 ;
  hh[54] =    0.058881968 ;
  hh[55] =    0.013770045 ;
  hh[56] =   -0.038995279 ;
  hh[57] =   -0.012880694 ;
  hh[58] =    0.027386143 ;
  hh[59] =    0.011811702 ;
  hh[60] =   -0.019685879 ;
  hh[61] =   -0.010618851 ;
  hh[62] =    0.014214474 ;
  hh[63] =    0.009349699 ;
  hh[64] =   -0.010193260 ;
  hh[65] =   -0.008061168 ;
  hh[66] =    0.007193218 ;
  hh[67] =    0.006796937 ;
  hh[68] =   -0.004958832 ;
  hh[69] =   -0.005601968 ;
  hh[70] =    0.003310219 ;
  hh[71] =    0.004505447 ;
  hh[72] =   -0.002119814 ;
  hh[73] =   -0.003532792 ;
  hh[74] =    0.001282415 ;
  hh[75] =    0.002694497 ;
  hh[76] =   -0.000716451 ;
  hh[77] =   -0.001995909 ;
  hh[78] =    0.000351416 ;
  hh[79] =    0.001431150 ;
  hh[80] =   -0.000132227 ;
  hh[81] =   -0.000990683 ;
  hh[82] =    0.000012722 ;
  hh[83] =    0.000658752 ;
  hh[84] =    0.000041510 ;
  hh[85] =   -0.000418689 ;
  hh[86] =   -0.000057142 ;
  hh[87] =    0.000252195 ;
  hh[88] =    0.000052293 ;
  hh[89] =   -0.000142494 ;
  hh[90] =   -0.000039310 ;
  hh[91] =    0.000074188 ;
  hh[92] =    0.000025226 ;
  hh[93] =   -0.000034629 ;
  hh[94] =   -0.000013699 ;
  hh[95] =    0.000013693 ;
  hh[96] =    0.000005855 ;
  hh[97] =   -0.000003967 ;
  hh[98] =   -0.000001475 ;
  hh[99] =    0.000000000 ;
}

void COsf2xView::Interpolate()
{
	int i;

	AllocateMemory3();

	for(i = 0; i < wavesize; i++) {
		IpWave[i*2] = InWave[i];
		IpWaveR[i*2] = InWaveR[i];
		IpWave[i*2+1] = 0.0;
		IpWaveR[i*2+1] = 0.0;
	}
}

void COsf2xView::PutWavInfo()
{
	char s[10];
	int numwritten;
	int i, m;
	FILE *ifp;
	CString filename_sv;
	CFileDialog dlgF(FALSE, "NULL", "test1.wav");

	if( dlgF.DoModal() == IDOK)	{
		filename_sv = dlgF.GetPathName();
		ifp = fopen( filename_sv, "wb" );
		if (ifp != NULL) { // 
			sprintf(s, "RIFF"); 
			numwritten = fwrite( s, 4, 1, ifp );
			bytesinfile_sv = bytesinfile + wavesize * chbytes_per_sample;
			put_ulong(bytesinfile_sv, ifp); // total bytes in the file
			sprintf(s, "WAVEfmt "); 
			numwritten = fwrite( s, 8, 1, ifp );
			put_ulong(16, ifp); // 16 bytes -- always
			put_ushort(1, ifp); // 1: pcm
			put_ushort(mono1_stereo2, ifp); // 1: mono, 2; stereo
			samplingfreq_sv = samplingfreq * 2;
			put_ulong(samplingfreq_sv, ifp); // sampling frequency	
			bytes_per_sec_sv = bytes_per_sec * 2;
			put_ulong(bytes_per_sec_sv, ifp); // bytes per second
			put_ushort(chbytes_per_sample, ifp); // channels * bytes per sample
			put_ushort(bitlength, ifp); // bit length
			sprintf(s, "datafmt "); 
			numwritten = fwrite( s, 4, 1, ifp );
			totalbytes_sv = totalbytes + wavesize * chbytes_per_sample;
			put_ulong(totalbytes_sv, ifp); // total bytes of wav data
			if (mono1_stereo2 == 1) {
				for (i = 0; i < wavesize * 2; i++) { // write mono wav data
					if (bytes_per_sample == 2) 
						put_ushort((short)OutWave[i], ifp);
					else 
						put_ubyte((short)OutWave[i], ifp);
				}
			} else {
				for (i = 0; i < wavesize * 2 * 2; i++) { // write stereo wav data 
					m = i / 2;
					if (bytes_per_sample == 2) 
						if(i%2==0) put_ushort((short)OutWave[m], ifp);
						else put_ushort((short)OutWaveR[m], ifp);
					else
						if(i%2==0) put_ubyte((short)OutWave[m], ifp);
						else put_ubyte((short)OutWaveR[m], ifp);
				}
			}
			fclose( ifp );
		} else { 
			CDlgWrErr dlg;
			if (dlg.DoModal() == IDOK) {
			}
		}
	}
}

void COsf2xView::put_ulong(long x, FILE *f)
{
    unsigned char s[4];
	long divident;
	int numwritten;

	s[3] = (unsigned char)(x / 256LU / 256LU / 256LU);
	divident = x - s[3] * 256LU * 256LU * 256LU;
	s[2] = (unsigned char)(divident / 256LU / 256LU);
	divident = x - s[3] * 256LU * 256LU * 256LU - s[2] * 256LU * 256LU;
	s[1] = (unsigned char)(divident / 256LU);
	s[0] = (unsigned char)(x - s[3] * 256LU * 256LU * 256LU 
			- s[2] * 256LU * 256LU - s[1] * 256LU);

	numwritten = fwrite( s, 4, 1, f );
}

void COsf2xView::put_ushort(short x, FILE *f)
{
    unsigned char s[2];
	int numwritten;

	s[1] = (unsigned char)(x / 256LU);
	s[0] = (unsigned char)(x - s[1] * 256LU);

	numwritten = fwrite( s, 2, 1, f );
}

void COsf2xView::put_ubyte(short x, FILE *f)
{
    unsigned char s[1];
	int numwritten;

	s[0] = (unsigned char)(x + 128);

	numwritten = fwrite( s, 1, 1, f );
}

void COsf2xView::OnMenuWvsv() 
{
	if(wave_loaded == TRUE) PutWavInfo();
	InvalidateRect(NULL, TRUE);		
}

void COsf2xView::OnMenuRng() 
{
	CDlgRng dlg;

	dlg.m_scaley = yrng;
	dlg.m_sliderx = xstart;
	if (dlg.DoModal() == IDOK) {
		yrng = dlg.m_scaley;
		xstart = dlg.m_sliderx;
		InvalidateRect(NULL, TRUE);
	}	
}

void COsf2xView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CRect rectClient;
	GetClientRect(&rectClient);
	pDC -> SetMapMode(MM_ANISOTROPIC);
	pDC -> SetWindowOrg(0,0);
	pDC -> SetWindowExt(100,50);
	pDC -> SetViewportOrg(0,0);
	pDC -> SetViewportExt(550, 350); // `TCYݒ

	CFont* pfontCurrent = pDC -> GetCurrentFont();
	LOGFONT lfCurrentFont;
	pfontCurrent -> GetObject(sizeof(LOGFONT), &lfCurrentFont);
	CFont fontBig;
	lfCurrentFont.lfHeight = 12; // tHgTCYijݒ
	lfCurrentFont.lfWidth = 6; // tHgTCYijݒ

	fontBig.CreateFontIndirect(&lfCurrentFont);
	CFont* defaultFont = (CFont*)pDC -> SelectObject(&fontBig);

	CView::OnPrint(pDC, pInfo);
}
